# individual configuration
variables:

  TARGET_PAGETITLE: 
    value: "Service-Projekt zur Versionierung der CI-Pipeline-Dokumente für Pandoc"
    description: "Erscheint in Titelzeile der Dokumente (Title-Tag um Head)"

  ABSOLUTPATH_FOR_IMAGEURLS: 
    value: 'https\:\/\/oer-informatik\.gitlab\.io\/service\/ci-pipeline\/'
    description: "Pfad, in dem die Artefakte dieses Repos veröffentlicht werden."
  
  ABSOLUTPATH_FOR_PANDOC: 
    value: 'https\:\/\/oer-informatik\.gitlab\.io\/service\/ci-pipeline\/'
    description: "Pfad, unter dem Default-Dokumente gefunden werden, die für alle gleich sind. Nicht ändern."

# v2
preparepandoc:
  image:
    name: registry.gitlab.com/oer-informatik/service/course-pandoc-preparation-for-wp/main:latest
    entrypoint: [""]
  stage: build
  script:
    - echo "start preparation"
    -  (for SOURCE_FILENAME in *.md; do echo "Prepare $SOURCE_FILENAME"; /build/pandoc-preparation.sh ${SOURCE_FILENAME%".md"} --project-url=${CI_PROJECT_URL}; done);
    - echo "end preparation"
  artifacts:
    untracked: true
    expire_in: 15min

pages:
  image:
    name: pandoc/latex:2.7
    entrypoint: [""]
  stage: deploy
  dependencies:
    - preparepandoc
  script:
    - ls -l
    # generate output files
    - echo "start Converting"
    # PDF-Export disabled - delete next comment if nessesary
    #- |
    #  (for SOURCE_FILENAME in *-prepared.md; 
    #   do echo "Convert $SOURCE_FILENAME  to PDF"; 
    #   pandoc title.txt $SOURCE_FILENAME -f markdown -t latex -s -o ${SOURCE_FILENAME%"-prepared.md"}.pdf --metadata pagetitle="${SOURCE_FILENAME%"-prepared.md"} ($CI_PROJECT_TITLE)" --webtex ;
    #  done);
    #- |
    #  (for SOURCE_FILENAME in *-prepared.md; 
    #   do echo "Convert $SOURCE_FILENAME to HTML"; 
    #   pandoc title.txt $SOURCE_FILENAME -f markdown -t html -s -o ${SOURCE_FILENAME%"-prepared.md"}.html --metadata pagetitle="${SOURCE_FILENAME%"-prepared.md"} ($CI_PROJECT_TITLE)" --include-in-header=metadata.json --katex --css pandoc.css ; 
    #   # korrigiere TABLE-WIDTH-Angaben
    #   sed -E -i 's/(<col style="width: )([0-9]{1,2}%)(" \/>)/\1\*\3/' ${SOURCE_FILENAME%"-prepared.md"}.html;    
    #  done);
    - |
      # Erstelle WPHTML- Codeschnipsel zum Einfügen in Wordpress
      (for SOURCE_FILENAME in *-prepared.md; 
        do echo "Convert $SOURCE_FILENAME to MD with absolutpaths"; 
        cp $SOURCE_FILENAME ${SOURCE_FILENAME%"-prepared.md"}.WPMD; 
        # Ersetze die relativen Bild-Pfadnamen durch absolute ins Repository (für Wordpress)
        sed -E -i "s/(\!.*?\]\()([^h][^t].*?)\)/\1$ABSOLUTPATH_FOR_IMAGEURLS\2)/g" ${SOURCE_FILENAME%"-prepared.md"}.WPMD;
        pandoc title.txt ${SOURCE_FILENAME%"-prepared.md"}.WPMD -f markdown -t html -s -o ${SOURCE_FILENAME%"-prepared.md"}.WPHTML --metadata pagetitle="${SOURCE_FILENAME%"-prepared.md"} ($CI_PROJECT_TITLE)" --include-in-header=metadata.json --katex --css pandoc.css;
        # Entkerne den HTML-HEADER (und ab </body>), damit der Code in Wordpress eingefügt werden kann
        sed -E -i "/<\!DOCTYPE/,/<\/title>/d" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML; 
        sed -E -i "/<\/head>/,/<\/header>/d" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML; 
        sed -E -i "/<\/body/,/<\/html>/d" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML; 
        # Ersetze den lokalen Pandoc-Pfad durch einen zentralen
        sed -E -i "s/(href=\")(pandoc.css)(\")/\1$ABSOLUTPATH_FOR_PANDOC\2\3/" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML; 
        sed -E -i "/<\!--\[if lt IE 9\]>/,/<\!\[endif\]-->/d" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML; 
        # korrigiere TABLE-WIDTH-Angaben
        sed -E -i 's/(<col style="width: )([0-9]{1,2}%)(" \/>)/\1\*\3/' ${SOURCE_FILENAME%"-prepared.md"}.WPHTML;
        # entferne <p></p> Tags, die durch Markdown Zeilenumbrüche um <span>-Tags ergänzt wurden 
        sed -E -i "s/(<p>)(<[\/]?span[^>]*>[^<]*?)(<\/p>)/\2/" ${SOURCE_FILENAME%"-prepared.md"}.WPHTML;
       done);
    - echo "End Converting"
    - mkdir .public
    - cp -r * .public
    - mv .public public
    - ls -lha public/
  artifacts:
    paths:
      - public
  only:
  - main